//+------------------------------------------------------------------+
//|                                                  Base150-Bot.mq4 |
//|                                                     Buenos-Aires |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Buenos-Aires"
#property link      ""



extern int TimeFrame = 60;
int slippage = 4;


extern double StopLoss   = 30;
extern double TakeProfit = 30;
extern bool MartIn = False;

extern double lot = 0.5;

extern bool TimeFilter = False;
extern int TradeBeginTime = 8;
extern int TradeEndTime = 20;

double spread, point;
double Ballance = 0.0;
string symbol;
int digits;

int init() 
 {
  symbol = Symbol();
  spread = MarketInfo(symbol,MODE_SPREAD);
  point = MarketInfo(symbol,MODE_POINT);
  digits = MarketInfo(symbol,MODE_DIGITS);
    
  return(0);
  } 

int deinit(){return(0);}


int start()
  { 
    double price, SL, TP;
    int a;
    
    if(TimeFilter)
      {
       if(Hour() < TradeBeginTime || Hour() > TradeEndTime) return(0);
        }
    
    RefreshRates();
        
    if(If_Buy_6_150(symbol, TimeFrame,Bid)) 
      {       
       price = NormalizeDouble(iMA(symbol, TimeFrame, 6, 0, MODE_EMA, PRICE_CLOSE,0)+ spread*point, digits);
       SL = price - point*StopLoss;
       TP = price +  point*TakeProfit;     
       if(SellPositions(symbol) > 0) CloseSellPosition(symbol);
       if(BuyPositions(symbol) == 0) { a = OrderSend(symbol,OP_BUY,lot(),price,slippage,SL,TP,NULL,0,0,Red);}
       
       if(a != -1) Sleep(60000*TimeFrame);
       } 
       
    if(If_Sell_6_150(symbol, TimeFrame,Bid)) 
      {
       price = NormalizeDouble(iMA(symbol, TimeFrame, 6, 0, MODE_EMA, PRICE_CLOSE,0), digits);
       SL = price + point*StopLoss + spread*point;
       TP = price -  point*TakeProfit;     
       if(BuyPositions(symbol) > 0) CloseBuyPosition(symbol);
       if(SellPositions(symbol) == 0) { a = OrderSend(symbol,OP_SELL,lot(),price,slippage,SL,TP,NULL,0,0,Red);}
       
       if(a != -1) Sleep(60000*TimeFrame);
       }    
    
    if(If_Buy_25_150(symbol, TimeFrame,Bid)) 
      {
       price = NormalizeDouble(iMA(symbol, TimeFrame, 25, 0, MODE_EMA, PRICE_CLOSE,0)+spread*point, digits);
       SL = price - point*StopLoss;
       TP = price +  point*TakeProfit;     
       if(SellPositions(symbol) > 0) CloseSellPosition(symbol);
       if(BuyPositions(symbol) == 0) { a = OrderSend(symbol,OP_BUY,lot(),price,slippage,SL,TP,NULL,0,0,Red);}
       
       if(a != -1) Sleep(60000*TimeFrame);
       } 
       
       
    if(If_Sell_25_150(symbol, TimeFrame,Bid)) 
      {
       price = NormalizeDouble(iMA(symbol, TimeFrame, 25, 0, MODE_EMA, PRICE_CLOSE,0), digits);
       SL = price + point*StopLoss + spread*point;
       TP = price - point*TakeProfit;     
       if(BuyPositions(symbol) > 0) CloseBuyPosition(symbol);
       if(SellPositions(symbol) == 0) { a = OrderSend(symbol,OP_SELL,lot(),price,slippage,SL,TP,NULL,0,0,Red);}
       
       if(a != -1) Sleep(60000*TimeFrame);
       }    
    
   return(0);
  }
 
 int If_Buy_6_150(string symbol, int tf, double price)
   {    
    double EMA6 = iMA(symbol, tf, 6, 0, MODE_EMA, PRICE_CLOSE,0);    
    
    if(price > EMA6 + 2*point || price < EMA6 - 2*point) return(0);
    if(EMA6 <= iMA(symbol, tf, 150, 0, MODE_EMA, PRICE_CLOSE,0)) return(0);
    
    for(int i = 1; i <= Bars-1; i++)
      {
       if(iMA(symbol, tf, 6, 0, MODE_EMA, PRICE_CLOSE,i) >= iMA(symbol, tf, 150, 0, MODE_EMA, PRICE_CLOSE,i) &&
          iMA(symbol, tf, 6, 0, MODE_EMA, PRICE_CLOSE,i+1) < iMA(symbol, tf, 150, 0, MODE_EMA, PRICE_CLOSE,i+1))
          
          {int n = i; break;}      
       }
       
        
       for(i = 1; i <= Bars-1; i++)
         {
          if(iLow(symbol, tf,i) <= iMA(symbol, tf, 6, 0, MODE_EMA, PRICE_CLOSE,i))         
          {int n1 = i; break;}      
         }
    
       if(n1 < n) return(0);
       else return(1);    
    }
 
 int If_Sell_6_150(string symbol, int tf, double price)
   {    
    double EMA6 = iMA(symbol, tf, 6, 0, MODE_EMA, PRICE_CLOSE,0);
        
    if(price > EMA6 + 2*point || price < EMA6 - 2*point) return(0);
    if(EMA6 >= iMA(symbol, tf, 150, 0, MODE_EMA, PRICE_CLOSE,0)) return(0);
    
    for(int i = 1; i <= Bars-1; i++)
      {
       if(iMA(symbol, tf, 6, 0, MODE_EMA, PRICE_CLOSE,i) <= iMA(symbol, tf, 150, 0, MODE_EMA, PRICE_CLOSE,i) &&
          iMA(symbol, tf, 6, 0, MODE_EMA, PRICE_CLOSE,i+1) > iMA(symbol, tf, 150, 0, MODE_EMA, PRICE_CLOSE,i+1))
          
          {int n = i; break;}      
       }
       
        
       for(i = 1; i <= Bars-1; i++)
         {
          if(iHigh(symbol, tf,i) >= iMA(symbol, tf, 6, 0, MODE_EMA, PRICE_CLOSE,i))         
          {int n1 = i; break;}      
         }
    
       if(n1 < n) return(0);
       else return(1);    
    }
 
  int If_Buy_25_150(string symbol, int tf, double price)
   {    
    double EMA25 = iMA(symbol, tf, 25, 0, MODE_EMA, PRICE_CLOSE,0);
        
    if(price > EMA25 + 2*point || price < EMA25 - 2*point) return(0);
    
    if(EMA25 <= iMA(symbol, tf, 150, 0, MODE_EMA, PRICE_CLOSE,0)) return(0);
    
    for(int i = 1; i <= Bars-1; i++)
      {
       if(iMA(symbol, tf, 25, 0, MODE_EMA, PRICE_CLOSE,i) >= iMA(symbol, tf, 150, 0, MODE_EMA, PRICE_CLOSE,i) &&
          iMA(symbol, tf, 25, 0, MODE_EMA, PRICE_CLOSE,i+1) < iMA(symbol, tf, 150, 0, MODE_EMA, PRICE_CLOSE,i+1))
          
          {int n = i; break;}      
       }
       
        
       for(i = 1; i <= Bars-1; i++)
         {
          if(iLow(symbol, tf,i) <= iMA(symbol, tf, 25, 0, MODE_EMA, PRICE_CLOSE,i))         
          {int n1 = i; break;}      
         }
    
       if(n1 < n) return(0);
       else return(1);    
    }
  
  int If_Sell_25_150(string symbol, int tf, double price)
   {    
    double EMA25 = iMA(symbol, tf, 25, 0, MODE_EMA, PRICE_CLOSE,0);
        
    if(price > EMA25 + 2*point || price < EMA25 - 2*point) return(0);
    
    if(EMA25 >= iMA(symbol, tf, 150, 0, MODE_EMA, PRICE_CLOSE,0)) return(0);
    
    for(int i = 1; i <= Bars-1; i++)
      {
       if(iMA(symbol, tf, 25, 0, MODE_EMA, PRICE_CLOSE,i) <= iMA(symbol, tf, 150, 0, MODE_EMA, PRICE_CLOSE,i) &&
          iMA(symbol, tf, 25, 0, MODE_EMA, PRICE_CLOSE,i+1) > iMA(symbol, tf, 150, 0, MODE_EMA, PRICE_CLOSE,i+1))
          
          {int n = i; break;}      
       }
       
        
       for(i = 1; i <= Bars-1; i++)
         {
          if(iHigh(symbol, tf,i) >= iMA(symbol, tf, 25, 0, MODE_EMA, PRICE_CLOSE,i))         
          {int n1 = i; break;}      
         }
    
       if(n1 < n) return(0);
       else return(1);    
    }
     
//+------------------------------------------------------------------+

int SellPositions(string symbol)
     {
      int k = 0;
      if(OrdersTotal() > 0) 
      {
       for(int i=1; i<=OrdersTotal(); i++)
        {
         if(OrderSelect(i-1,SELECT_BY_POS)==true && OrderSymbol() == symbol && OrderType() == OP_SELL) 
          k = k + 1;
         }
       }   
   return(k);     
     }
     
int BuyPositions(string symbol)     
     {
      int k = 0;
      if(OrdersTotal() > 0) 
      {
       for(int i=1; i<=OrdersTotal(); i++)
        {
         if(OrderSelect(i-1,SELECT_BY_POS)==true && OrderSymbol() == symbol && OrderType() == OP_BUY) 
          k = k + 1;
         }
       }   
   return(k);     
     }

void CloseSellPosition(string symbol)
      {
       if(OrdersTotal() > 0)
        {
         for(int i=1; i<=OrdersTotal(); i++)
          {
           if(OrderSelect(i-1,SELECT_BY_POS)==true && OrderSymbol() == symbol && OrderType() == OP_SELL) 
             RefreshRates();
             OrderClose(OrderTicket(),OrderLots(),Ask,slippage,Red);
         }
       }   
   return(0);      
      }
      
void CloseBuyPosition(string symbol)
      {
       if(OrdersTotal() > 0)
        {
         for(int i=1; i<=OrdersTotal(); i++)
          {
           if(OrderSelect(i-1,SELECT_BY_POS)==true && OrderSymbol() == symbol && OrderType() == OP_BUY) 
             RefreshRates();
             OrderClose(OrderTicket(),OrderLots(),Bid,slippage,Red);
         }
       }   
   return(0);      
      }     

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 double lot() {      int k=1;  if ( !MartIn ) return (lot);
 
       if (OrdersHistoryTotal()==0) return(lot); 
       
       int i,accTotal=OrdersHistoryTotal()-1; 
      
     
                 for  (i=accTotal;i>-1;i--)//  ...
                 
                            { if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false)
                            
                       { Print("      (",GetLastError(),")");
                       
                               break; } //    ...
                               
        if(OrderCloseTime()!=0 && OrderProfit()>0)   bool mart=true; //-------
  
        if (OrderCloseTime()!=0  && OrderProfit()<0 && !mart)   k=2*k;

                                      
     }//-end-for-
             return(k*lot);}//-----
   //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx